/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.generator;

import com.google.common.collect.Iterables;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.xtext.example.mydsl.scheme.Command;
import org.xtext.example.mydsl.scheme.Define;
import org.xtext.example.mydsl.scheme.Lista;
import org.xtext.example.mydsl.scheme.Model;
import org.xtext.example.mydsl.scheme.Operation;
import org.xtext.example.mydsl.scheme.Print;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class SchemeGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    fsa.generateFile("teste.txt", this.start(resource));
  }
  
  public CharSequence start(final Resource r) {
    StringConcatenation _builder = new StringConcatenation();
    {
      Iterable<Model> _filter = Iterables.<Model>filter(IteratorExtensions.<EObject>toIterable(r.getAllContents()), Model.class);
      for(final Model m : _filter) {
        {
          EList<Command> _commands = m.getCommands();
          for(final Command c : _commands) {
            CharSequence _compile = this.compile(c);
            _builder.append(_compile);
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  protected CharSequence _compile(final Operation o) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("const soma = ");
    int _valueUm = o.getValueUm();
    _builder.append(_valueUm);
    _builder.append(" ");
    String _arit_op = o.getArit_op();
    _builder.append(_arit_op);
    _builder.append(" ");
    int _valueDois = o.getValueDois();
    _builder.append(_valueDois);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  protected CharSequence _compile(final Define d) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("const ");
    String _varUm = d.getVarUm();
    _builder.append(_varUm);
    _builder.append(" = ");
    int _varValue = d.getVarValue();
    _builder.append(_varValue);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  protected CharSequence _compile(final Print p) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("console.log(\"");
    String _string = p.getString();
    _builder.append(_string);
    _builder.append("\");");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  protected CharSequence _compile(final Lista l) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("console.log(");
    EList<Integer> _numeros = l.getNumeros();
    _builder.append(_numeros);
    _builder.append(")");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence compile(final Command d) {
    if (d instanceof Define) {
      return _compile((Define)d);
    } else if (d instanceof Lista) {
      return _compile((Lista)d);
    } else if (d instanceof Operation) {
      return _compile((Operation)d);
    } else if (d instanceof Print) {
      return _compile((Print)d);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(d).toString());
    }
  }
}
